package nl.amis.demo.josql;

import java.util.ArrayList;
import java.util.List;

import nl.amis.demo.josql.domain.Person;

import junit.framework.TestCase;

public class TestClassRoom extends TestCase {

	private Person peter = new Person ("Peter", "Paaltjes", "1111BG", "Badhoevedorp");
	private List<Person> students;
	private ClassRoom classroom;
	
	protected void setUp() throws Exception {
		super.setUp();
		students = new ArrayList<Person>();
		students.add(new Person ("Piet", "Paaltjes", "1000AA", "Amsterdam"));
		students.add(new Person ("Jan", "Doedel", "9999GG", "Utrecht"));
		students.add(peter);
		students.add(new Person ("Piet", "de Jong", "6754RF", "Groningen"));
		classroom = new ClassRoom (students);
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}

	/*
	 * Test method for 'nl.amis.demo.josql.ClassRoom.findStudent(String)'
	 */
	public void testFindStudent() 
	{
			//Search 1 Peter
		List<Person> foundStudents = classroom.findStudent("Peter");
		Person foundPeter = foundStudents.get(0);
		assertNotNull (foundStudents);
		assertEquals("Search Peter", peter, foundPeter);
			// better make a separate test for a Persoon
		assertEquals (peter.getFirstname(), foundPeter.getFirstname());
		
			// Search 2 Pieten
		foundStudents = classroom.findStudent("Piet");
		assertEquals("Search Piet", 2, foundStudents.size());
		
		for (Person student : foundStudents)
		{
			assertEquals ("Voornaam Piet", "Piet", student.getFirstname());
		}
		
			// Search non existing student
		foundStudents = classroom.findStudent("Hans");
		assertNull("No students found", foundStudents);
	}
}
